#include "stdafx.h"
 #include "cpss_dialog.h"
#include <stdio.h>
#include "ThreshDlg.h"


#define  HEIGHT_BUTTON_WIDTH 80
 

#define CELL_H ROW_H
 
#define CELL_W 152
 
#define Y_BMP 15+8
 
 typedef struct {
	UINT nID; //tire identify
	char  pstr[16]; // used when nID==-1
	POINT pt;
	//POINT ptBut;
	COLORREF color;
	CMyBitmap placehold;
}  DISPLAY_CELL;
 static const int  threshBmpId[4]={IDB_PLACE_141_YELLOW ,IDB_PLACE_141_GREEN , IDB_PLACE_141_YELLOW,IDB_PLACE_141};

// #define NULL_MYBITMAP  NULL
static DISPLAY_CELL  display_cell [ ]={
	 
	{ IDS_THRESH_NIED,{0},{160,130},TUHUANG_CLR },{IDS_THRESH_SOLL ,{0},{325,130},0x00ff00}, 
	{ IDS_THRESH_HOCH,{0},{490,130},TUHUANG_CLR },
	
	{IDS_THRESH_TOLE,{0},{325,293},0x999999}
};
	 
 #define m_btnlist m_Btns
 #define m_btAct (&m_Btns[1])
 #define m_btPM (&m_Btns[2])

//static DWORD WINAPI CommandTask(void*para );


 
//#define TIMEOUT_COMMAND 10000
//static HANDLE g_hCommandThread=NULL;
 

static const BUTTON_ITEM Button_EngInfo[] = 
{
	//{ 416, 121,	44,	    44,ID_BACKSPACE ,IDB_BACKSPACE    ,IDB_BACKSPACE_DN },  //For Name
	//{ 416, 165,	44,	    44,ID_UPICON    ,IDB_UPICON       ,IDB_UPICON_DN},
	{ Btn_CancelX, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},

};

static const BUTTON_ITEMEX Button1_EngInfo[] = 
{
	 { 468,  Btn_CancelY+1,	215, 70,IDS_SEND  ,IDBI_BTN_GREEN ,IDBI_BTN_GREEN_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL},
	//{ 560 , 371,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL},
	//{ 452, 376,	250,42,IDS_CFG    ,IDB_BUTTON250  ,0,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_CFG},
	//{ 452,30,	228,72,IDD_BUTTONS_RIGHT    ,IDD_BUTTONS_RIGHT      ,0}
};
//extern cCPSSFileInfo CpssFile;

//static HANDLE ghExitEvent=NULL;

LRESULT ThreshDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	int i=0;
	for( ; i<sizeof(Button_EngInfo)/sizeof(BUTTON_ITEM) ; i++)
	{
		CREATE_BTN_TRANS2(m_btnlist[i], m_nIDBACK, Button_EngInfo[i]);
	}

	CRect rect;
	rect = Button1_EngInfo[0].rt;
	
	 
	for(i=0; i<sizeof(Button1_EngInfo)/sizeof(BUTTON_ITEMEX) ; i++)
	{
		BOOL bEnable = true;
		
		CString str;
		str.LoadString(Button1_EngInfo[i].uId );
		CREATE_BTN_TRANS(m_btAct[i], m_nIDBACK,str,Button1_EngInfo[i]);
		
	}
 

	int count = sizeof(display_cell)/sizeof(DISPLAY_CELL);
	for(i=0;i<count;i++)
	{
		rect.left = display_cell[i].pt.x;rect.top = display_cell[i].pt.y ;
		rect.right= rect.left+ CELL_W; rect.bottom =rect.top+CELL_H;
		if(i<3){
			rect.OffsetRect(0,CELL_H+10);
		}else{
			rect.OffsetRect(CELL_W+14 ,-5);
		}
		m_btPM[i*2].CreateWndTrans(m_hWnd,m_nIDBACK,rect, display_cell[i].nID+100, IDBI_MINUS, IDBI_MINUS_DN);
		rect.left = rect.left +80;
		m_btPM[i*2+1].CreateWndTrans(m_hWnd,m_nIDBACK,rect, display_cell[i].nID+200, IDBI_PLUS, IDBI_PLUS_DN);
		
	}

	//DWORD dwID;
	//ghExitEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	//g_hCommandThread = CreateThread(NULL,0 , CommandTask ,(void*)m_hWnd,0, &dwID);


	//OnButton2(0,0,0, bHandled);
	
	//SetTimer(1,5000,NULL);
	int ids[3] = { IDB_Reifen_NIEDER  ,IDB_Reifen_SOLL ,IDB_Reifen_HOECH   };
	int x,y;
	for(i=0;i<3;i++)
	{
		x = display_cell[i].pt.x+40;
		y = Y_BMP;
		m_Icons[i].LoadBitmap( ids[i],m_nIDBACK,x,y );
		 
		
	}

	if(m_nSelectTire.GetSize()>0)
	{
		int nSel = m_nSelectTire[0];
		TIRE_CFG * cfg = find_cfg(nSel);
		//for(i=0;i<4;i++)
		{
			if(m_bTemp==0)
				memcpy( m_fVal, cfg->pressure, 4* sizeof(float));
			else memcpy( m_fVal, cfg->temp, 4* sizeof(float));
		}
	}
	VButtonWnd::OnInitDialog(uMsg, wParam, lParam, bHandled) ;
    return 0;  
}


void ThreshDlg::OnPaintExt(HDC hDC,CRect& rcPaint)
{
	DrawDC Draw(hDC);
	CCanvas canvas(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);Draw.SetDrawTextColor(RGB(0xff,0xff,0xff));
	CRect rect;
	HFONT hOldFont = Draw.SetFont(m_hBigFont);
	CString str;
	int count = sizeof(display_cell)/sizeof(DISPLAY_CELL);
	int i=m_bTemp; // do not display 
	 
	for(i;i<count;i++)
	{
		rect.left = display_cell[i].pt.x;rect.top = display_cell[i].pt.y;
		rect.right = rect.left+ CELL_W;rect.bottom = rect.top+ CELL_H;
		 
		 
		//Draw.DrawNewRect2(&rect,TRUE,TRUE,display_cell[i].color);
		draw_placeholder(display_cell[i].placehold,threshBmpId[i]);
		/*if(display_cell[i].placehold.m_hBitmap==NULL)
		{
			display_cell[i].placehold.LoadBitmap(threshBmpId[i],m_nIDBACK,rect.left,rect.top);
		}
		canvas.BitBlt(display_cell[i].placehold,rect.left,rect.top,TRUE);*/
		
		
		sprintf( display_cell[i].pstr,"%.1f " ,m_fVal[i]);
		Draw.DrawStringRect(convert_val(display_cell[i].pstr,m_bTemp?TEMP_UNIT:PRESS_UNIT),&rect,DT_CENTER|DT_VCENTER);
		if(i<3) rect.OffsetRect(0, -CELL_H-2);
		else rect.OffsetRect(-CELL_W-10,0);
		str.LoadString(display_cell[i].nID);
		Draw.DrawStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_CENTER|DT_VCENTER);
	}
	rect.left = display_cell[3].pt.x;rect.top =Btn_CancelY+1;
	rect.right = rect.left+200; rect.bottom = rect.top+Btn_CancelHeight;
	if(m_bTemp)
	{
		rect.left = display_cell[3].pt.x-80;rect.top =Btn_CancelY+1;
		rect.right = rect.left+200; rect.bottom = rect.top+Btn_CancelHeight;
		Draw.DrawStringRect(L"Reifentemperatur",&rect,DT_LEFT|DT_VCENTER);
	}else{
		rect.left = display_cell[3].pt.x;rect.top =Btn_CancelY+1;
		rect.right = rect.left+200; rect.bottom = rect.top+Btn_CancelHeight;
		Draw.DrawStringRect(L"Reifendruck",&rect,DT_LEFT|DT_VCENTER);
	}
	 

	Draw.SetFont(hOldFont);

 
	int x, y;
	for(i=m_bTemp;i<3;i++)
	{
		x = display_cell[i].pt.x+40;
		y = Y_BMP;
		canvas.BitBlt(m_Icons[i], x,y,TRUE);
		
	}
	 
}
 
LRESULT ThreshDlg::OnButton1(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	 
/*
	BUTTON_ITEM Button_bmp[] = 
	{
		{ Btn_CancelX-1, Btn_CancelY+1,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},
		{0,0,0,0,0,0,0}
	};

	BUTTON_ITEMEX Button_txt[] = 
	{
		{ 560 , 371,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,15},
		{0,0,0,0,0,0,0}
	};


	CpssMsgDlg dlg(IDB_BDCOMP_RESET,NULL,0);
	dlg.m_BmpButtonTmpl = Button_bmp;// Button_Cancel;
	dlg.m_TxtButtonTmpl = Button_txt ;
	if( dlg.DoModal() )
	{
		
	    PlaySound(IDR_WAVE,FALSE);
	}*/
	int i, c = m_nSelectTire.GetSize();
	if(c>0)
	{
		if(m_bTemp==0) 
		{
			float temp[4]={0};
			for(i=0;i<c;i++)
			{
				int nSel = m_nSelectTire[i];
				TIRE_CFG* cfg = find_cfg(nSel);
				if(cfg){
					memcpy( cfg->pressure, m_fVal,4*sizeof(float));
					if(i==0) memcpy( temp , cfg->temp, 4*sizeof(float));
				}
			}
			m_bTemp++;
			m_btPM[0].ShowWindow(SW_HIDE);m_btPM[1].ShowWindow(SW_HIDE);
			memcpy( m_fVal , temp, 4*sizeof(float));
			Invalidate();
		}else
		{
			for(i=0;i<c;i++)
			{
				int nSel = m_nSelectTire[i];
				TIRE_CFG* cfg = find_cfg(nSel);
				if(cfg) memcpy( cfg->temp, m_fVal,4*sizeof(float));
			}
			EndDialog(1);
		}
		
	}
	return 0;
}

BOOL ThreshDlg::validate_value(float val)
{
	return TRUE;
}

LRESULT ThreshDlg::OnThreshSet(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	int i=-1;
	float step=1;
	if(!m_bTemp) step=0.1;
	switch(wID-200)
	{
	case IDS_THRESH_NIED:
		if(m_fVal[0]>=m_fVal[1]) return 0;
		m_fVal[0]+=step;
		i=0;break;
	case IDS_THRESH_SOLL:
		if(  m_fVal[2]<=m_fVal[1] ) return 0;
		 m_fVal[1]+=step;
		i=1;break;
	case IDS_THRESH_HOCH:
		
		m_fVal[2]+=step;
		i=2;break;
	case IDS_THRESH_TOLE:

		m_fVal[3]+=step;
		i=3;break;
	}
	if(i==-1){
		 
		switch(wID-100)
		{
		case IDS_THRESH_NIED:
			if(!m_bTemp && m_fVal[0]< step) return 0;
			m_fVal[0]-=step;
			i=0;break;
		case IDS_THRESH_SOLL:
			if( m_fVal[1]<=m_fVal[0] ) return 0;
			m_fVal[1]-=step;
			i=1;break;
		case IDS_THRESH_HOCH:
			if(m_fVal[2]<=m_fVal[1]) return 0;
			m_fVal[2]-=step;
			i=2;break;
		case IDS_THRESH_TOLE:
			if(m_fVal[3]< step) return 0;
			m_fVal[3]-=step;
			i=3;break;
		}
		 
	}
	if(i!=-1){
		RECT rect; 	 
		rect.left = display_cell[i].pt.x;rect.top = display_cell[i].pt.y ;
		rect.right= rect.left+ CELL_W; rect.bottom =rect.top+CELL_H;
		::InvalidateRect(m_hWnd,&rect,FALSE);
		//::UpdateWindow(m_hWnd);
	}
  return 0;
}


LRESULT ThreshDlg::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	//SetEvent(ghExitEvent);
	//if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
	__restore_pre_window_handle__(m_hWnd);
	
	//CloseHandle(ghExitEvent);
	EndDialog(1);
	//PostQuitMessage(0);
	
	return 0;
}



LRESULT ThreshDlg::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	BOOL bHandled;
//	OnButton2(0,0,0, bHandled);
	return 0;
}


LRESULT ThreshDlg::OnUserIndicate(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
 

	return 0;
} 