#include "StdAfx.h"
#include "publicctrl.h"
#include "DrawLib.h"
#include "CPSS_Dialog.h"
#include "shellapi.h"

#ifndef IDB_BK_POP_DETAIL
#define IDB_BK_POP_DETAIL -1
#endif

extern HWND g_hListenWnd;
extern BOOL g_bGiveup;
#define   m_btStd m_Btns
#define   m_btCommand (m_Btns+3)

#define SOUND_POPUP_PATH  __FLASHDISK_W_ L"\\popup.wav"

void exec_with_params(const TCHAR *exe, const TCHAR *params, BOOL hidden)
{
    SHELLEXECUTEINFO sei;
    BOOL             res;

    if (NULL == exe)
        return;

    ZeroMemory(&sei, sizeof(sei));
    sei.cbSize  = sizeof(sei);
    sei.fMask   = SEE_MASK_FLAG_NO_UI;
    sei.lpVerb  = NULL;
    sei.lpFile  = exe;
    sei.lpParameters = params;
    if (hidden)
        sei.nShow = SW_HIDE;
    else
        sei.nShow   = SW_SHOWNORMAL;
    res = ShellExecuteEx(&sei);
}
void fire_wakeup_event();

extern DWORD g_dwPopTimeout;
extern TCHAR* g_pszFileDelay;
extern BOOL g_bPopDelay,g_bAutoClose;
HANDLE ghEventPopup = NULL;
BOOL g_bPopup = FALSE;
LRESULT CpssMsgDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
g_bPopup = TRUE;

//	SetWindowPos(HWND_TOPMOST,0,0,SCREEN_W,SCREEN_H,SWP_NOSIZE);
	int i=0;
	const BUTTON_ITEM * pBmpBut= m_BmpButtonTmpl;
	while(pBmpBut && pBmpBut->uId!=0){
	   CREATE_BTN_TRANS2( m_btStd[i],m_nIDBACK,(*pBmpBut));
	   pBmpBut++;
	   i++;

	}
	i=0;
	if(m_TxtButtonTmpl){
		const BUTTON_ITEMEX * pBmpBut= m_TxtButtonTmpl;
		while(pBmpBut && pBmpBut->uId!=0){
			CString str;
			if(pBmpBut->btTxtId) str.LoadString(pBmpBut->btTxtId);
			else str.LoadString(pBmpBut->uId); 
			CREATE_BTN_TRANS( m_btCommand[i],m_nIDBACK,str,(*pBmpBut));
			
			//m_btCommand[i].EnableWindow();
			pBmpBut++;
			i++;
		}
	}

	//if(m_nIDBACK==IDB_BK_POP_DETAIL)
	SetTimer(5,5000);

	if(m_toAlive>0) SetTimer(6,m_toAlive);
#ifdef UNDER_CE
	//PlaySound( (MAKEINTRESOURCE(IDW_POPUP)),::GetModuleHandle(NULL), SND_ASYNC|SND_RESOURCE);
	//PlaySound( SOUND_POPUP_PATH, (NULL), SND_ASYNC|SND_FILENAME);
	if( /*(m_TxtButtonTmpl && g_pszFileDelay ==NULL ) || */ m_nSoundCount>0||m_bSound)
	{	
		PlayCPSSSound();
		fire_wakeup_event();
		if(m_szExtraSound!=NULL) PlaySoundFile(m_szExtraSound,FALSE);
	}
#endif
	m_nTimerCount = 0;
	if(m_nAutoEndTimer>0) SetTimer(6,m_nAutoEndTimer);

	if(ghEventPopup==NULL) ghEventPopup = CreateEvent(NULL,TRUE,FALSE,L"POPUP:SHOW");   
	SetEvent(ghEventPopup); 
		VButtonWnd::OnInitDialog(uMsg,  wParam,  lParam,  bHandled);
    return 0;  
} 
LRESULT CpssMsgDlg::OnTimer (UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	if( (wParam)==0x6 && m_toAlive>0)
	{
		g_bPopup = FALSE;
		KillTimer(6);
		ShowWindow(SW_HIDE);
   		EndDialog(1);
	}else{
		m_nTimerCount++;
		if(g_bPopDelay)
		{
			g_bPopup = FALSE;
			ShowWindow(SW_HIDE);
	  		EndDialog(0x10);
		}else
		{
			  BOOL bOK = SetForegroundWindow(m_hWnd);
		      //SetWindowPos(HWND_TOPMOST,0,0,480,272,SWP_NOSIZE);
		}
		if( (g_bAutoClose && ( m_nIDBACK != IDB_BK ) ) )
		{
			//if((m_nTimerCount%6)==0) PlayCPSSSound();
			if(m_nTimerCount>=6||(g_dwPopTimeout==30 && m_nTimerCount>=2)) 
			{
				PlayCPSSSound();
				
			}
			if((DWORD)m_nTimerCount*5>=g_dwPopTimeout)
			{
				g_bPopup = FALSE;
				ShowWindow(SW_HIDE);
  				EndDialog(0x11);
			}
			
		}else if( m_nSoundCount>0)
		{
			 if((m_nTimerCount%6)==0)
			 {
				m_nSoundCount--;
				PlayCPSSSound();
			}
		}
	}
	return 0;
}
LRESULT CpssMsgDlg::OnCommand (UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
const BUTTON_ITEMEX * pBmpBut= m_TxtButtonTmpl;
const BUTTON_ITEM * pBmpBut2= m_BmpButtonTmpl;
//int i = 0;
	switch (LOWORD(wParam))
	{
	case IDOK:
	case IDCANCEL:
	case ID_CANCEL:
		bHandled = 0;
		return 0;
	}
	
	while(pBmpBut && pBmpBut->uId!=0)
	{
		if( LOWORD(wParam)==pBmpBut->uId)
		{
			bHandled = 1;

			
			EndDialog(pBmpBut->uId);
		}
		pBmpBut++;
		//i++;
	}	

	while(pBmpBut2 && pBmpBut2->uId!=0)
	{
		if( LOWORD(wParam)==pBmpBut2->uId)
		{
			bHandled = 1;
			EndDialog(pBmpBut2->uId);
		}
		pBmpBut2++;
		//i++;
	}
	return 0;
}

#if 0
LRESULT CpssMsgDlg::OnActivateApp (UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{  

	HWND hTask = (HWND) lParam;
	int act = LOWORD(wParam);
static BOOL g_bGiveup= FALSE;
	// a bit of trickery else the tooltips appear behind the main window
	// if we are active then remove topmost attribute because we are topmost anyway
	// else set it so that we remain topmost
	if(m_nIDBACK==IDB_BK_POP_DETAIL)
	{ 
		//::MessageBox(m_hWnd,L"2222",L"dd",MB_OK);
		if(!g_bGiveup)
		{
			if (act!=WA_INACTIVE)
				SetWindowPos(HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
			else
				SetWindowPos(HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		}else SetWindowPos(HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		if(act==WA_ACTIVE)  g_bGiveup = FALSE;
	}
	return 0;
}	
#endif
void CpssMsgDlg::OnPaintExt(HDC hDC,CRect& rcPaint)
{

	if( m_nIDBACK == IDB_BK )
	{
		if(m_sTitle){
			//HDC hDC=GetDC();
			if(fnDrawMessage)
				fnDrawMessage(hDC,m_sTitle,m_sExtra);
			else{
				DrawDC Draw(hDC);

				Draw.SetDrawBkMode(TRANSPARENT);
				Draw.SetDrawTextColor(RGB(0,0,0));
				Draw.SetDrawFontSize(TitleFontHeight,TitleFontWide,FW_NORMAL,__FONT_NORMAL__);
				//Draw.DrawGPSOverIPStringRect(m_sTitle,CRect(70,24,414,50),DT_LEFT|DT_EXPANDTABS);
				Draw.DrawGPSOverIPStringRect(m_sTitle,CRect(70,90,641,250),DT_CENTER|DT_VCENTER|DT_SINGLELINE);
			}

			//ReleaseDC(hDC);
		} 
		if(m_MsgString){
			
			//HDC hDC=GetDC();
			if(fnDrawMessage)
				fnDrawMessage(hDC,m_MsgString,m_sExtra);
			else{
				DrawDC Draw(hDC);

				Draw.SetDrawBkMode(TRANSPARENT);
				Draw.SetDrawTextColor(RGB(0,0,0));	 
				Draw.SetMsgBoxFont(); 
				CRect rect;
				rect.top= 0;
				rect.left = 80;
				rect.bottom = 300;
				rect.right = SCREEN_W - 80;
				CRect temp = rect;
 				int height  = ::DrawText(hDC,m_MsgString,wcslen(m_MsgString) ,temp,DT_CENTER|DT_WORDBREAK|DT_CALCRECT|DT_EXPANDTABS|DT_EDITCONTROL);
				rect.DeflateRect(0, (rect.Height()-height)/2) ;

				Draw.DrawGPSOverIPStringRect(m_MsgString,rect,DT_CENTER|DT_EXPANDTABS|DT_EDITCONTROL |DT_WORDBREAK);
				//Draw.DrawGPSOverIPStringRect(m_MsgString,CRect(80,110,720,380),DT_CENTER|DT_WORDBREAK |DT_EXPANDTABS );
	
			}
		}
	}else{
		//HDC hDC=GetDC();
		if(fnDrawMessage){
			if(m_sTitle==NULL )
				fnDrawMessage(hDC,m_MsgString,m_sExtra);
			else 
				fnDrawMessage(hDC,m_sTitle,m_sExtra);
		}
		else{
			DrawDC Draw(hDC);

			Draw.SetDrawBkMode(TRANSPARENT);
			Draw.SetDrawTextColor(RGB(0,0,0));

			Draw.SetDrawFontSize(40,17,FW_NORMAL,__FONT_NORMAL__);
			CRect rc(80,110,710,420);
			if(m_DrawList && m_DrawList->hasTwoIcon())
			{
				rc.top = 160;
			}
			Draw.DrawGPSOverIPStringRect(m_sTitle,rc,DT_CENTER|DT_EXPANDTABS);
			if(m_sExtra &&m_nIDBACK==IDB_BK_POP_DETAIL)// only for job application
			{
				Draw.SetDrawFontSize(18,8,FW_NORMAL,__FONT_NORMAL__);
				////
				Draw.DrawGPSOverIPStringRect(m_sExtra,CRect(EXTRA_TEXT_POS),DT_CENTER);
			}
		}
		//ReleaseDC(hDC);
	}
   // return 0;
}

LRESULT CpssMsgDlg::OnButtomYes(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	g_bPopup = FALSE;
	ShowWindow(SW_HIDE);
  	EndDialog(TRUE);
	return 0;
}
LRESULT CpssMsgDlg::OnButtomNo(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
g_bPopup = FALSE;
	ShowWindow(SW_HIDE);
	EndDialog(FALSE);
    return 0;
}

LRESULT CpssMsgDlg::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
g_bPopup = FALSE;
	ShowWindow(SW_HIDE);

   	EndDialog(FALSE);
	return 0;
}


LRESULT CpssMsgDlg::OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_DrawList->ChangeSkin();
EnumChildWindows(m_hWnd,EnumCallback ,0);
	return 0;
}
static BUTTON_ITEMEX Button_Yes[3]= {
	{ 150,  300,	201, 75,IDOK      ,IDBI_BUTTON_121x43,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL ,IDS_YES},
	{ 463,  300,	201, 75,IDCANCEL   ,IDBI_BUTTON_121x43,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_NO},
	{ 0, 0,	0, 0,0    ,0     ,0}
};	
int DoConfirm(CString strMsg, UINT idBmp ,BOOL bSound,BUTTON_ITEMEX* pButtons)
{
 
	if(pButtons==NULL) pButtons = Button_Yes;
	CpssMsgDlg dlg(IDB_BK,strMsg,idBmp);
	dlg.m_BmpButtonTmpl = 0;//&Button_Yes[0];
	dlg.m_TxtButtonTmpl = pButtons; //0;
	dlg.m_bSound = bSound;
	return dlg.DoModal();
}
int DoConfirm(UINT ids, UINT idBmp ,BOOL bSound,BUTTON_ITEMEX* pButtons)
{
	CString strMsg;
	strMsg.LoadString(ids);
	return DoConfirm(strMsg,  idBmp ,bSound, pButtons);
}
static RECT SMALL_TEXT_RECT={  186 ,140 ,620,320};
static RECT 	  TEXT_RECT={  80 ,0 ,720,SCREEN_H-10};
static RECT* s_prcText = &TEXT_RECT;
static void DrawCenterText(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	CRect rect(*s_prcText);
	
	CRect temp = rect;
	DrawDC Draw(hDC);
	Draw.SetMsgBoxFont() ;
	int height  = ::DrawText(hDC,msg,wcslen(msg) ,temp,DT_CENTER|DT_WORDBREAK|DT_CALCRECT|DT_EXPANDTABS|DT_EDITCONTROL);
	rect.DeflateRect(0, (rect.Height()-height)/2) ;

	Draw.DrawGPSOverIPStringRect(msg,rect,DT_CENTER|DT_EXPANDTABS|DT_EDITCONTROL |DT_WORDBREAK);
}
static BUTTON_ITEM Button_Cancel_Full[2] = 
{
	{ Btn_CancelX, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL     ,IDBI_CANCEL_DN},
	{ 0, 0,	0, 0,0    ,0     ,0}
};
void ShowSimpleMsgBox(int idTxt,int idBMP, CRect& rtIcon,int idBk)
{

	s_prcText = &TEXT_RECT ;
	CString strTitle;
	strTitle.LoadString(idTxt);
	CpssMsgDlg dlg(idBk,strTitle,idBMP ,rtIcon);
	dlg.m_BmpButtonTmpl = Button_Cancel_Full;
	dlg.m_TxtButtonTmpl = 0;
	dlg.fnDrawMessage = DrawCenterText;
	dlg.DoModal();
}

void ShowSimpleMsgBox(int idTxt,int idBMP)
{

	s_prcText = &TEXT_RECT ;
	CString strTitle;
	strTitle.LoadString(idTxt);
	CpssMsgDlg dlg(IDB_BK,strTitle,idBMP);
	dlg.m_BmpButtonTmpl = Button_Cancel_Full;
	dlg.m_TxtButtonTmpl = 0;
	dlg.fnDrawMessage = DrawCenterText;
	dlg.DoModal();
}

void ShowSmallMsgBox(int idTxt,int idBMP)
{
	BUTTON_ITEM Button_Cancel[2] = {
	{   600, 304,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN },
	{0,0,0,0,0,0}};
	s_prcText = &SMALL_TEXT_RECT ;
	CString str;
	str.LoadString(idTxt);
	CpssMsgDlg dlg(IDB_BK_POP_DETAIL,str,idBMP);
	dlg.m_BmpButtonTmpl = Button_Cancel;
	dlg.m_TxtButtonTmpl = 0 ;
 
	dlg.fnDrawMessage = DrawCenterText;
	dlg.DoModal();
}


static void DrawCFGHelp(HDC hDC,TCHAR *txt,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);
	TCHAR *__msg = wcsdup(txt);
	TCHAR* msg = __msg;
	int style  = DT_LEFT|DT_WORDBREAK|DT_EDITCONTROL|DT_EXPANDTABS;
	int height = 0;
	CRect temp = TEXT_RECT;

	height  = ::DrawText(hDC,msg,wcslen(msg) ,temp,style|DT_CALCRECT );
	int y = 100;
	if(height > 60) y=70;
	CRect rect(80,y,Btn_CancelX,SCREEN_H-20);
	do{
		
		TCHAR* pStart = wcschr(msg,TCHAR('<'));
		if(pStart)
		{
			*pStart = 0;
			if(msg!=pStart)
			{
				Draw.SetHelpFont() ;
				Draw.DrawGPSOverIPStringRect(msg,rect,style);
				height  = ::DrawText(hDC,msg,wcslen(msg) ,temp,style|DT_CALCRECT );
				msg = pStart+1;
				rect.top+=height+4;//4;
			}
			
			TCHAR* pEnd = wcschr(pStart+1,TCHAR('>'));
			if(pEnd)
			{
				Draw.SetHelpFont(TRUE) ;
				*pEnd = 0;
				Draw.DrawGPSOverIPStringRect(pStart+1,rect,style);
				rect.top+=30;
				msg = pEnd+1;
			}
		}else {
			Draw.SetHelpFont() ;
			Draw.DrawGPSOverIPStringRect(msg,rect,style);
			break;
		}

	}while(msg[0]);
	 
	free(msg);
//	Draw.DrawGPSOverIPStringRect(msg,CRect(80,y,SCREEN_W-80,SCREEN_H-100),DT_LEFT |DT_WORDBREAK|DT_EDITCONTROL);
}

void HelpBox(int idTxt,int idBMP)
{
 
	CString wcsMsg;
	wcsMsg.LoadString(idTxt);
	CpssMsgDlg dlg(IDB_BK,wcsMsg,idBMP);
	dlg.m_BmpButtonTmpl =Button_Cancel_Full;
	dlg.m_TxtButtonTmpl = 0; //0;
	dlg.fnDrawMessage = DrawCFGHelp;
	dlg.m_bSound = FALSE;
 
	dlg.DoModal();

}